<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select class="form-control" id="drink-select">
        <option value="0">Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick = "onBtnDisplayClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý khi tải trang
    function onPageLoading(){
      //b1,b2: nằm ở sk xử lý nút
      //b3 gọi Api lấy danh sách đồ uống 
      var vXmlHttp = new XMLHttpRequest();//tạo đối tượng request
      processApi(vXmlHttp);
      //b4 gán vào select element
      vXmlHttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            
            //subtask 3: chuyển data thành object và đưa vào phần tử select            
            fillDataToSelect(vXmlHttp.responseText);
          }
        };
        
    }
    function onBtnDisplayClick(){
      var vDrinkSelectObj = {
          maNuocUong: null,
          tenNuocUong: "",
        };
       
      //b1: Đọc dữ liệu
      docDuLieu(vDrinkSelectObj);
    
      //b2: kiểm tra dữ liệu
      var vCheck = kiemTraDuLieu(vDrinkSelectObj);
      if (vCheck){               
        //b4: Xử lý hiển thị
        dataDisplay(vDrinkSelectObj);
      }
    }
       

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(xhttp.responseText); //ghi response text ra console.log
          }
        };
      xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      xhttp.send();
    }

    //API lấy danh sách đồ uống
    function processApi(paramXmlHttp){
      "use strict";
      paramXmlHttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramXmlHttp.send();
    }
    //hàm đổ dữ liệu vào select element
    function fillDataToSelect(paramData){
      console.log(paramData); //ghi response text ra console.log
      var vDrinkDataObj = JSON.parse(paramData); //chuyển data thành object
      //truy xuất phần tử Select
      var vDrinkSelect = document.getElementById("drink-select");
            //thêm option vào select element
            var vIndex = 0;
            while (vIndex < vDrinkDataObj.length){
              var vOptionDrink = document.createElement("option");
              vOptionDrink.value = vDrinkDataObj[vIndex].maNuocUong;
              vOptionDrink.text = vDrinkDataObj[vIndex].tenNuocUong;
              vDrinkSelect.add(vOptionDrink);
              vIndex++;
            }
    }
    
    //khai báo hàm đọc dữ liệu select
    function docDuLieu(paramDrinkSelect){
      var vDrinkSelect = document.getElementById("drink-select");
      paramDrinkSelect.maNuocUong = vDrinkSelect.value;
      paramDrinkSelect.tenNuocUong = vDrinkSelect.options[vDrinkSelect.selectedIndex].text;
      console.log(paramDrinkSelect);
    }
    //khai báo hàm kiểm tra dữ liệu
    function kiemTraDuLieu(paramDrinkSelect){
      if (paramDrinkSelect.maNuocUong == "0") {
        alert ("Cần chọn 1 loại đồ uống!");
        return false;
      }
      else return true;
    }
    //khai báo hàm hiển thị thông tin đồ uống được chọn
    function dataDisplay(paramDrinkSelect){         
      console.log("Đồ uống được chọn: " + "Mã nước uống - " + paramDrinkSelect.maNuocUong + ", Tên nước uống - " + paramDrinkSelect.tenNuocUong);
    }
    
  </script>
</body>

</html>